diff --git a/libavfilter/vf_histogram.c b/libavfilter/vf_histogram.c
index 0d2d087beb..d6928d6b08 100644
--- a/libavfilter/vf_histogram.c
+++ b/libavfilter/vf_histogram.c
@@ -185,9 +185,9 @@ static int query_formats(AVFilterContext *ctx)
     return 0;
 }
 
-static const uint8_t black_yuva_color[4] = { 0, 127, 127, 255 };
+static const uint8_t black_yuva_color[4] = { 0, 128, 128, 255 };
 static const uint8_t black_gbrp_color[4] = { 0, 0, 0, 255 };
-static const uint8_t white_yuva_color[4] = { 255, 127, 127, 255 };
+static const uint8_t white_yuva_color[4] = { 255, 128, 128, 255 };
 static const uint8_t white_gbrp_color[4] = { 255, 255, 255, 255 };
 
 static int config_input(AVFilterLink *inlink)
diff --git a/tests/ref/fate/filter-histogram-levels b/tests/ref/fate/filter-histogram-levels
index 697d7d19c0..e1329593e3 100644
--- a/tests/ref/fate/filter-histogram-levels
+++ b/tests/ref/fate/filter-histogram-levels
@@ -3,53 +3,53 @@
 #codec_id 0: rawvideo
 #dimensions 0: 256x636
 #sar 0: 1/1
-0,          0,          0,        1,   488448, 0xc27a6cac
-0,          1,          1,        1,   488448, 0xf00a152e
-0,          2,          2,        1,   488448, 0x060b8c70
-0,          3,          3,        1,   488448, 0xf75d6ee2
-0,          4,          4,        1,   488448, 0xd7a7f06e
-0,          5,          5,        1,   488448, 0x585281a5
-0,          6,          6,        1,   488448, 0xb06e3ee8
-0,          7,          7,        1,   488448, 0x201d0b8c
-0,          8,          8,        1,   488448, 0x4e14e319
-0,          9,          9,        1,   488448, 0x5aef5cca
-0,         10,         10,        1,   488448, 0x57018668
-0,         11,         11,        1,   488448, 0x2ad45b3f
-0,         12,         12,        1,   488448, 0x62cc36b8
-0,         13,         13,        1,   488448, 0x9e84585e
-0,         14,         14,        1,   488448, 0xe6552e42
-0,         15,         15,        1,   488448, 0x13b90c2c
-0,         16,         16,        1,   488448, 0xf9557145
-0,         17,         17,        1,   488448, 0x818340bc
-0,         18,         18,        1,   488448, 0x5112c6e1
-0,         19,         19,        1,   488448, 0x5d5b8f43
-0,         20,         20,        1,   488448, 0xf2101ea6
-0,         21,         21,        1,   488448, 0x4266af4d
-0,         22,         22,        1,   488448, 0xb358806e
-0,         23,         23,        1,   488448, 0xe336aa60
-0,         24,         24,        1,   488448, 0x64fcc339
-0,         25,         25,        1,   488448, 0x86e4b729
-0,         26,         26,        1,   488448, 0x48c380d0
-0,         27,         27,        1,   488448, 0xaee36fd3
-0,         28,         28,        1,   488448, 0x20b84429
-0,         29,         29,        1,   488448, 0x84d85542
-0,         30,         30,        1,   488448, 0x94aea169
-0,         31,         31,        1,   488448, 0x6278fa2c
-0,         32,         32,        1,   488448, 0xaadf998d
-0,         33,         33,        1,   488448, 0x29bba90d
-0,         34,         34,        1,   488448, 0xef1117ad
-0,         35,         35,        1,   488448, 0xd961e36d
-0,         36,         36,        1,   488448, 0xff53296e
-0,         37,         37,        1,   488448, 0x41f381f9
-0,         38,         38,        1,   488448, 0x66fcfc2a
-0,         39,         39,        1,   488448, 0x758bb472
-0,         40,         40,        1,   488448, 0xefc6dc9e
-0,         41,         41,        1,   488448, 0x77fccb69
-0,         42,         42,        1,   488448, 0x7a1d82a4
-0,         43,         43,        1,   488448, 0xc9d61a1b
-0,         44,         44,        1,   488448, 0x8e689deb
-0,         45,         45,        1,   488448, 0x52133e75
-0,         46,         46,        1,   488448, 0xcc0a098e
-0,         47,         47,        1,   488448, 0x045cd17f
-0,         48,         48,        1,   488448, 0x97f89963
-0,         49,         49,        1,   488448, 0xa1f835ff
+0,          0,          0,        1,   488448, 0x0a904cf7
+0,          1,          1,        1,   488448, 0x3820f56a
+0,          2,          2,        1,   488448, 0x4e126cbb
+0,          3,          3,        1,   488448, 0x3f734f2d
+0,          4,          4,        1,   488448, 0x1fbdd0b9
+0,          5,          5,        1,   488448, 0xa05961f0
+0,          6,          6,        1,   488448, 0xf8751f33
+0,          7,          7,        1,   488448, 0x6824ebc8
+0,          8,          8,        1,   488448, 0x961bc364
+0,          9,          9,        1,   488448, 0xa2f63d15
+0,         10,         10,        1,   488448, 0x9f0866b3
+0,         11,         11,        1,   488448, 0x72db3b8a
+0,         12,         12,        1,   488448, 0xaad31703
+0,         13,         13,        1,   488448, 0xe68b38a9
+0,         14,         14,        1,   488448, 0x2e6b0e8d
+0,         15,         15,        1,   488448, 0x5bc0ec68
+0,         16,         16,        1,   488448, 0x416b5190
+0,         17,         17,        1,   488448, 0xc98a2107
+0,         18,         18,        1,   488448, 0x9919a72c
+0,         19,         19,        1,   488448, 0xa5626f8e
+0,         20,         20,        1,   488448, 0x3a26fee2
+0,         21,         21,        1,   488448, 0x8a6d8f98
+0,         22,         22,        1,   488448, 0xfb5f60b9
+0,         23,         23,        1,   488448, 0x2b4c8aab
+0,         24,         24,        1,   488448, 0xad03a384
+0,         25,         25,        1,   488448, 0xceeb9774
+0,         26,         26,        1,   488448, 0x90ca611b
+0,         27,         27,        1,   488448, 0xf6ea501e
+0,         28,         28,        1,   488448, 0x68bf2474
+0,         29,         29,        1,   488448, 0xccdf358d
+0,         30,         30,        1,   488448, 0xdcb581b4
+0,         31,         31,        1,   488448, 0xaa7fda77
+0,         32,         32,        1,   488448, 0xf2e679d8
+0,         33,         33,        1,   488448, 0x71c28958
+0,         34,         34,        1,   488448, 0x3727f7e9
+0,         35,         35,        1,   488448, 0x2177c3b8
+0,         36,         36,        1,   488448, 0x476909b9
+0,         37,         37,        1,   488448, 0x89fa6244
+0,         38,         38,        1,   488448, 0xaf03dc75
+0,         39,         39,        1,   488448, 0xbd9294bd
+0,         40,         40,        1,   488448, 0x37dcbce9
+0,         41,         41,        1,   488448, 0xc003abb4
+0,         42,         42,        1,   488448, 0xc22462ef
+0,         43,         43,        1,   488448, 0x11ecfa57
+0,         44,         44,        1,   488448, 0xd66f7e36
+0,         45,         45,        1,   488448, 0x9a1a1ec0
+0,         46,         46,        1,   488448, 0x1420e9ca
+0,         47,         47,        1,   488448, 0x4c63b1ca
+0,         48,         48,        1,   488448, 0xdfff79ae
+0,         49,         49,        1,   488448, 0xe9ff164a